package HyperEps.publish;

import static org.junit.Assert.*;

import java.util.ArrayList;
import java.util.Random;

import org.junit.Test;



public class MyTests {

	// some very basic test
	@Test
	public void HypTestOne() {
		Point [] p = {
				new Point(1,3),
				new Point(2,2),
				new Point(3,1)
		};
		
		// refrence point must be above the front
		Point r = new Point(4,4);
		
		System.out.println("val : " + HYPSSP.calcValue(p, 1, r));
		assertEquals(4.0, HYPSSP.calcValue(p, 1, r), 1.0e-6);
		assertEquals(5.0, HYPSSP.calcValue(p, 2, r), 1.0e-6);
		assertEquals(6.0, HYPSSP.calcValue(p, 3, r), 1.0e-6);
	}
	
	// this tests approximates DTLZ1 with hypervolume for different k
/*	@Test 
	public void ApproxDTLZ1() {
		
		Point ref = new Point(11,11);

				double frontLength = 0.5; 
				
				int sampleSize = 100000;

				int length = sampleSize;
				
				ArrayList<Point> list = new ArrayList<>();

				for (int n = 0; n < length; n++) {
					double start =  (frontLength * n) / (length - 1);
					double x = start;
					double y = 0.5 -x;
					list.add(new Point(x, y));
				}
			

			Point[] approx = new Point[list.size()];

			for (int n = 0; n < list.size(); n++) {
				approx[n] = list.get(n);
			}
			
			System.out.println("approx DTLZ1");
			
			for (int k=10; k<=1000; k+=70) {
				double approxHyp = HYPSSP.calcValue(approx, k, ref);
				
				// this is the optimal formula given
				double opt = 120 + 7.0/8.0 - 0.125 / (k-1);
				assertEquals(opt, approxHyp, 1.0e-5);
				System.out.println("k : "+ k  + " ok! ");
			}
		}*/
		
		@Test 
		// test non dominant
		public void NonDominantTest() {
			
			// repeat this 10 time to be sure
			for (int it = 0; it<10; it++ ){
				Point p[] = new Point[100000];
				
				Random rnd = new Random();
				
				for(int n=0; n<p.length; n++) {
					p[n] = new Point(rnd.nextDouble(), rnd.nextDouble());
				}
				
				p = EPSSSP.makeNonDominant(p);
				
				for (int n=0; n<p.length-1; n++) {
					assertFalse(p[n].x <= p[n+1].x && p[n].y <= p[n+1].y);
				}			
			}
			
		}
	
		
		// simple eps test
		@Test
		public void SimpleEpsTest() {
			Point[] p = new Point[] { new Point(1,3), new Point(2,2), new Point(3,1) };
			
			EPSSSP eps = new EPSSSP(p, p);
			
			assertEquals(1, eps.slowSolution(1, false), 1.0e-6);
			assertEquals(1, eps.slowSolution(2, false), 1.0e-6);
			assertEquals(0, eps.slowSolution(3, false), 1.0e-6);
		}
		
		// compare the slow version O(|A| * |B|) 
		// with  the fast version  O((|A| log |B| + |B|) log (|A| |B|))
		@Test
		public void SimpleEpsPointCompare() {
			Point[] p = new Point[1000];
			
			for(int n=0; n<1000; n++) {
				p[n] = new Point(n, 10-n*0.001);
			}
			
			EPSSSP eps = new EPSSSP(p, p);

			System.out.println("comparing eps ");

			for(int k=10; k<=1000; k+=80) {
				// without extrema
				assertEquals(eps.fastSolution(k, false), eps.slowSolution(k, false), 1.0e-6);
				
				// with extrema
				assertEquals(eps.fastSolution(k, true), eps.slowSolution(k, true), 1.0e-6);

			}
			
			System.out.println("finished");
			
			
		}

	}


	

